enum kind {plus, minus, uminus};

struct Plus{
  Expr *left;
  Expr *right;
};

struct Minus{
  Expr *left;
  Expr *right;
};

struct UMinus{
  Expr *operand;
};

struct Expr{
  enum kind _kind;
  union {
    struct Plus _plus;
    struct Minus _minus;
    struct UMinus _uminus;
  } children;
};

Expr* make_plus(Expr*l, Expr*r){

  Expr* result = malloc(sizeof(struct Expr));
  result->_kind = plus;
  result->children._plus.left = l;
  result->children._plus.right = r;
  return result;
}
